Ginkgo: gko::LinOp Class Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::LinOp Class Referenceabstract
Inheritance diagram for gko::LinOp:
[legend]
Collaboration diagram for gko::LinOp:
[legend]

## Public Member Functions
LinOp * | apply (ptr_param< const LinOp > b, ptr_param< LinOp > x)
| Applies a linear operator to a vector (or a sequence of vectors).
const LinOp * | apply (ptr_param< const LinOp > b, ptr_param< LinOp > x) const
LinOp * | apply (ptr_param< const LinOp > alpha, ptr_param< const LinOp > b, ptr_param< const LinOp > beta, ptr_param< LinOp > x)
| Performs the operation x = alpha * op(b) + beta * x.
const LinOp * | apply (ptr_param< const LinOp > alpha, ptr_param< const LinOp > b, ptr_param< const LinOp > beta, ptr_param< LinOp > x) const
const dim< 2 > & | get_size () const noexcept
| Returns the size of the operator.
virtual bool | apply_uses_initial_guess () const
| Returns true if the linear operator uses the data given in x as an initial guess.
LinOp & | operator= (const LinOp &)=default
| Copy-assigns a LinOp.
LinOp & | operator= (LinOp &&other)
| Move-assigns a LinOp.
| LinOp (const LinOp &)=default
| Copy-constructs a LinOp.
| LinOp (LinOp &&other)
| Move-constructs a LinOp.

## Constructor & Destructor Documentation

## ◆ LinOp() [1/2]

gko::LinOp::LinOp | ( | const LinOp & |  | ) |
| default

Copy-constructs a LinOp.

Inherits executor and size from the input.

References LinOp().

Referenced by apply(), apply(), apply(), apply(), LinOp(), LinOp(), operator=(), and operator=().

## ◆ LinOp() [2/2]

gko::LinOp::LinOp | ( | LinOp && | other | ) |
| inline

Move-constructs a LinOp.

Inherits executor and size from the input, which will have size 0x0 and unchanged executor afterwards.

References LinOp().

## Member Function Documentation

## ◆ apply() [1/4]

LinOp * gko::LinOp::apply | ( | ptr_param< const LinOp > | alpha,
|  | ptr_param< const LinOp > | b,
|  | ptr_param< const LinOp > | beta,
|  | ptr_param< LinOp > | x )
| inline

Performs the operation x = alpha * op(b) + beta * x.

Parameters

  alpha | scaling of the result of op(b)
  b | vector(s) on which the operator is applied
  beta | scaling of the input x
  x | output vector(s)

Returns
  this

References gko::ptr_param< T >::get(), LinOp(), and gko::make_temporary_clone().

## ◆ apply() [2/4]

const LinOp * gko::LinOp::apply | ( | ptr_param< const LinOp > | alpha,
|  | ptr_param< const LinOp > | b,
|  | ptr_param< const LinOp > | beta,
|  | ptr_param< LinOp > | x ) const
| inline

References gko::ptr_param< T >::get(), LinOp(), and gko::make_temporary_clone().

## ◆ apply() [3/4]

LinOp * gko::LinOp::apply | ( | ptr_param< const LinOp > | b,
|  | ptr_param< LinOp > | x )
| inline

Applies a linear operator to a vector (or a sequence of vectors).

Performs the operation x = op(b), where op is this linear operator.

Parameters

  b | the input vector(s) on which the operator is applied
  x | the output vector(s) where the result is stored

Returns
  this

References gko::ptr_param< T >::get(), LinOp(), and gko::make_temporary_clone().

## ◆ apply() [4/4]

const LinOp * gko::LinOp::apply | ( | ptr_param< const LinOp > | b,
|  | ptr_param< LinOp > | x ) const
| inline

References gko::ptr_param< T >::get(), LinOp(), and gko::make_temporary_clone().

## ◆ apply_uses_initial_guess()

virtual bool gko::LinOp::apply_uses_initial_guess | ( |  | ) | const
| inlinevirtual

Returns true if the linear operator uses the data given in x as an initial guess.

Returns false otherwise.

Returns
  true if the linear operator uses the data given in x as an initial guess. Returns false otherwise.

## ◆ get_size()

const dim< 2 > & gko::LinOp::get_size | ( |  | ) | const
| inlinenoexcept

Returns the size of the operator.

Returns
  size of the operator

## ◆ operator=() [1/2]

LinOp & gko::LinOp::operator= | ( | const LinOp & |  | ) |
| default

Copy-assigns a LinOp.

Preserves the executor and copies the size.

References LinOp().

## ◆ operator=() [2/2]

LinOp & gko::LinOp::operator= | ( | LinOp && | other | ) |
| inline

Move-assigns a LinOp.

Preserves the executor and moves the size. The moved-from object has size 0x0 afterwards, but its executor is unchanged.

References LinOp().

The documentation for this class was generated from the following file:

- ginkgo/core/base/lin_op.hpp